"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const CodeframeFormatter_1 = require("./CodeframeFormatter");
const BasicFormatter_1 = require("./BasicFormatter");
// declare function implementation
function createFormatter(type, options) {
    switch (type) {
        case 'basic':
        case undefined:
            return BasicFormatter_1.createBasicFormatter();
        case 'codeframe':
            return CodeframeFormatter_1.createCodeframeFormatter(options);
        default:
            throw new Error(`Unknown "${type}" formatter. Available types are: basic, codeframe.`);
    }
}
exports.createFormatter = createFormatter;
