"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const os_1 = __importDefault(require("os"));
const chalk_1 = __importDefault(require("chalk"));
const path_1 = require("path");
const issue_1 = require("../issue");
const normalizeSlash_1 = __importDefault(require("../utils/path/normalizeSlash"));
function createWebpackFormatter(formatter, context) {
    return function webpackFormatter(issue) {
        const severity = issue.severity.toUpperCase();
        const file = issue.file ? normalizeSlash_1.default(path_1.relative(context, issue.file)) : undefined;
        const location = issue.location ? issue_1.formatIssueLocation(issue.location) : undefined;
        const color = issue.severity === 'warning' ? chalk_1.default.yellow : chalk_1.default.red;
        const header = [severity, 'in', file].concat(location ? [location] : []).join(' ');
        return [color.bold(header), formatter(issue), ''].join(os_1.default.EOL);
    };
}
exports.createWebpackFormatter = createWebpackFormatter;
