"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const typescript_1 = __importDefault(require("typescript"));
const TypeScriptVueExtensionConfiguration_1 = require("./extension/vue/TypeScriptVueExtensionConfiguration");
const normalizeSlash_1 = __importDefault(require("../utils/path/normalizeSlash"));
function createTypeScriptReporterConfiguration(compiler, options) {
    let tsconfig = typeof options === 'object' ? options.tsconfig || 'tsconfig.json' : 'tsconfig.json';
    // ensure that `tsconfig` is an absolute path with normalized slash
    tsconfig = normalizeSlash_1.default(path_1.default.isAbsolute(tsconfig)
        ? tsconfig
        : path_1.default.resolve(compiler.options.context || process.cwd(), tsconfig));
    // convert json compilerOptions to ts.CompilerOptions
    const convertResults = typescript_1.default.convertCompilerOptionsFromJson(Object.assign({ skipDefaultLibCheck: true, skipLibCheck: true }, (typeof options === 'object' ? options.compilerOptions || {} : {})), compiler.options.context || process.cwd(), tsconfig);
    const convertedOptions = convertResults.options || {};
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    const { configFilePath } = convertedOptions, compilerOptions = __rest(convertedOptions, ["configFilePath"]);
    return Object.assign(Object.assign({ enabled: options !== false, memoryLimit: 2048, build: false }, (typeof options === 'object' ? options : {})), { tsconfig: tsconfig, compilerOptions: compilerOptions, extensions: {
            vue: TypeScriptVueExtensionConfiguration_1.createTypeScriptVueExtensionConfiguration(typeof options === 'object' && options.extensions ? options.extensions.vue : undefined),
        }, diagnosticOptions: Object.assign({ syntactic: false, semantic: true, declaration: false, global: false }, ((typeof options === 'object' && options.diagnosticOptions) || {})) });
}
exports.createTypeScriptReporterConfiguration = createTypeScriptReporterConfiguration;
